=== debian/changelog ===
kvazaar (2.3.1-3) unstable; urgency=medium

  * Change to use my @debian.org address.
  * Add patch from upstream to fix compilation with gcc-15.
  * d/control: Update Standards-Version to 4.7.2

 -- Joachim Bauch <fancycode@debian.org>  Tue, 19 Aug 2025 08:31:20 +0200

kvazaar (2.3.1-2) unstable; urgency=medium

  [ Alex Myczko ]
  * allow double builds

  [ Joachim Bauch ]
  * Add patch from upstream to fix hanging tests on i386.
  * No need to forward privacy-related patch.
  * d/rules: Run tests on all platforms again. (Closes: #1078175)

 -- Joachim Bauch <bauch@struktur.de>  Tue, 20 Aug 2024 23:35:07 +0200

kvazaar (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Remove patch no longer necessary with new upstream version.
  * d/control: Update "Standards-Version" to 4.7.0
  * d/control: Mark "-doc" package as "Multi-Arch: foreign".
  * d/rules: Disable tests on platforms where they timeout.
  * Only run doxygen when building indep packages.
  * d/control: Migrate to "pkgconf".

 -- Joachim Bauch <bauch@struktur.de>  Wed, 22 May 2024 11:41:54 +0200

kvazaar (2.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1060341)

 -- Joachim Bauch <bauch@struktur.de>  Mon, 22 Jan 2024 21:05:38 +0100
