=== debian/changelog ===
kvazaar (2.3.2-1) unstable; urgency=medium

  * Mention closed bug in changelog.
  * Add autopkgtests that run the upstream tests.
  * d/control: Improve package description.
  * New upstream version 2.3.2
  * Remove patches applied upstream.

 -- Joachim Bauch <fancycode@debian.org>  Wed, 01 Oct 2025 22:50:29 +0200
