=== debian/control ===
--- 
+++ 
@@ -26,7 +26,19 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Description: HEVC encoder - application
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  This package contains the kvazaar application.
 
@@ -37,7 +49,19 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Description: HEVC encoder - shared library
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  This package contains the shared library.
 
@@ -51,7 +75,19 @@
 Suggests:
  kvazaar-doc
 Description: HEVC encoder - development files
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  The development headers for compiling programs that use kvazaar are provided
  by this package.
@@ -63,6 +99,18 @@
 Depends:
  ${misc:Depends}
 Description: HEVC encoder - documentation
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  This package contains the documentation.
