=== debian/tests/control ===
Tests: run-tests
Depends:
 ffmpeg,
 hm,
 kvazaar
Restrictions:
