=== debian/watch ===
version=4
opts="searchmode=plain" \
https://api.github.com/repos/ultravideo/kvazaar/releases?per_page=50 \
https://github.com/[^/]+/[^/]+/releases/download/[^/]+/kvazaar-v?@ANY_VERSION@.tar.gz
